/*
 * CentralRegistrationClass.java
 *
 * This class was automatically created by the OpenOffice.org Wizard.
 */

package org.openoffice.demo;

import static de.init.util.logging.SimpleLog.log;

import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;

import de.init.its.api.process.OdtStyleConfiguration;
import de.init.its.util.Util;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.JarURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.jar.Attributes;
import java.util.jar.Manifest;

/**
 * Entry class for LibreOffice
 *
 * @author generated
 */
public class CentralRegistrationClass {

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        String regClassesList = getRegistrationClasses();
        StringTokenizer t = new StringTokenizer(regClassesList, " ");
        while (t.hasMoreTokens()) {
            String className = t.nextToken();
            if (className != null && className.length() != 0) {
                try {
                    Class regClass = Class.forName(className);
                    Method writeRegInfo = regClass.getDeclaredMethod("__getComponentFactory", new Class[]{String.class});
                    Object result = writeRegInfo.invoke(regClass, sImplementationName);
                    if (result != null) {
                       return (XSingleComponentFactory)result;
                    }
                }
                catch (ClassNotFoundException ex) {
                	log("exception " + ex);
                } catch (ClassCastException ex) {
                	log("exception " + ex);
                } catch (SecurityException ex) {
                	log("exception " + ex);
                } catch (NoSuchMethodException ex) {
                	log("exception " + ex);
                } catch (IllegalArgumentException ex) {
                	log("exception " + ex);
                } catch (InvocationTargetException ex) {
                	log("exception " + ex);
                } catch (IllegalAccessException ex) {
                	log("exception " + ex);
                }
            }
        }
        return null;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        boolean bResult = true;
        String regClassesList = getRegistrationClasses();
        StringTokenizer t = new StringTokenizer(regClassesList, " ");
        while (t.hasMoreTokens()) {
            String className = t.nextToken();
            if (className != null && className.length() != 0) {
                try {
                    Class regClass = Class.forName(className);
                    Method writeRegInfo = regClass.getDeclaredMethod("__writeRegistryServiceInfo", new Class[]{XRegistryKey.class});
                    Object result = writeRegInfo.invoke(regClass, xRegistryKey);
                    bResult &= ((Boolean)result).booleanValue();
                }
                catch (ClassNotFoundException ex) {
                	log("exception " + ex);
                } catch (ClassCastException ex) {
                	log("exception " + ex);
                } catch (SecurityException ex) {
                	log("exception " + ex);
                } catch (NoSuchMethodException ex) {
                	log("exception " + ex);
                } catch (IllegalArgumentException ex) {
                	log("exception " + ex);
                } catch (InvocationTargetException ex) {
                	log("exception " + ex);
                } catch (IllegalAccessException ex) {
                	log("exception " + ex);
                }
            }
        }
        return bResult;
    }

    private static String getRegistrationClasses() {
        CentralRegistrationClass c = new CentralRegistrationClass();
        String name = c.getClass().getCanonicalName().replace('.', '/').concat(".class");
        try {
        	
        	try { // add to load styles
				// hook into system loader and make styling available
        		Enumeration<URL> stylesFile = c.getClass().getClassLoader().getResources("META-INF/mlw-global.css");
        		while(stylesFile.hasMoreElements()) {
        			URL url = stylesFile.nextElement();
        			if(url.getPath().contains("mlw-global.css")) {
        				OdtStyleConfiguration.load(url);
        			}
        		}
				
			} catch (Exception e) {
				// TODO: handle exception
			}
			Enumeration<URL> urlEnum = c.getClass().getClassLoader().getResources("META-INF/MANIFEST.MF");
            while (urlEnum.hasMoreElements()) {
                URL url = urlEnum.nextElement();
                JarURLConnection jarConnection =
                    (JarURLConnection) url.openConnection();
                Manifest mf = jarConnection.getManifest();

                Attributes attrs = (Attributes) mf.getAttributes(name);
                if ( attrs != null ) {
                    String classes = attrs.getValue( "RegistrationClasses" );
                    return classes;
                }
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }

        return "";
    }

    /** Creates a new instance of CentralRegistrationClass */
    private CentralRegistrationClass() {
    }
}
