 /* ===========================================================================
 *   Copyright (C) 2013 by ]init[ AG für digitale Kommunikation
 * -----------------------------------------------------------------------------
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *  See also the full LGPL text here: http://www.gnu.org/copyleft/lesser.html
 * ===========================================================================*/
package de.init.its.api.ds;

import java.io.Serializable;


/**
 * Defines an ITS Tag Element Attribute
 * 
 * @author mkandora
 *
 */
public interface IitsAttribute extends Serializable {
	
	/**
	 * Returns the its tag attribute name
	 * @return
	 */
	public String getItsAttributeName();
	
	/**
	 * Returns the its tag attribute value
	 * @return
	 */
	public String getItsAttributeValue();
	
	/**
	 * Sets the attribute value and name
	 * 
	 * @param name 
	 * @param value
	 */
	public void setAttribute(final String name, final String value);
	
	/**
	 * Sets the its attribute name for this Attribute
	 * @param name the its name
	 */
	public void setAttributeName(final String name);
	
	/**
	 * Sets the attribute value
	 * 
	 * @param value the its attribute value
	 */
	public void setAttributeValue(final String value);
	
	/**
	 * Returns the Default value for this its attribute
	 * @return
	 */
	public IitsAttribute getDefaults();
	
	/**
	 * copy IiTsAttribute values
	 * 
	 * @param attribute
	 */
	public void copy(final IitsAttribute attribute);
	
	/**
	 * Returns a copy of this attribute
	 * @return
	 */
	public IitsAttribute copy();
}
