 /* ===========================================================================
 *   Copyright (C) 2013 by ]init[ AG für digitale Kommunikation
 * -----------------------------------------------------------------------------
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or (at
 *  your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this library; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *  See also the full LGPL text here: http://www.gnu.org/copyleft/lesser.html
 * ===========================================================================*/
package de.init.its.ds;

import java.io.Serializable;

import de.init.its.api.ds.IitsAttribute;
import de.init.its.api.ds.IitsTagElement;

/**
 * An its document consists of the internal tree representation of
 * all its nodes and additional properties
 * 
 * @author mkandora
 *
 */
public class ItsDocument implements Serializable {
	
	private static final long serialVersionUID = 1569728653887944727L;

	/** The root element */
	private IitsTagElement root;
	
	/** path to resource file*/
	private String resourceName;
	
	/**
	 * constructs a new its document using an existing its root element
	 * 
	 * @param root
	 * @param nameSpace
	 */
	public ItsDocument(final IitsTagElement root) {
		this.root = root;
	}
	
	public ItsDocument() {
		this(null);
	}
	
	/**
	 * Returns the root its element
	 * @return
	 */
	public IitsTagElement getRoot() {
		return root;
	}
	
	/**
	 * Sets the its root element
	 * 
	 * @param root
	 */
	public void setRoot(final IitsTagElement root) {
		this.root = root;
	}
	
	/**
	 * get the associated resource name
	 * 
	 * @return
	 */
	public String getResourceName() {
		return resourceName;
	}
	
	/**
	 * sets the associated resource name
	 * 
	 * @param resourceName the associated resource document
	 */
	public void setResourceName(final String resourceName) {
		this.resourceName = resourceName;
	}
	
	
}
